pub trait Summary {
  fn summary(&self) -> String;
}

pub struct BlogPost {
  pub title: String,
  pub author: String,
  pub content: String,
}

impl Summary for BlogPost {
  fn summary(&self) -> String {
      format!("{} by {}", self.title, self.author)
  }
}

fn main() {
  let p = BlogPost {
      title: String::from("some title"),
      author: String::from("xiexianbin"),
      content: String::from("abcd23"),
  };

  println!("{}", p.summary())
}
